<?php

namespace App\Http\Controllers;

use App\Models\HorarioReceso;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class HorarioRecesoController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = HorarioReceso::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new HorarioReceso())->getFillable());
        $horarioReceso = HorarioReceso::create($payload);

        return response()->json([
            'success' => true,
            'data' => $horarioReceso,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(HorarioReceso $horarioReceso): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $horarioReceso,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, HorarioReceso $horarioReceso): JsonResponse
    {
        $payload = $request->only((new HorarioReceso())->getFillable());
        $horarioReceso->update($payload);

        return response()->json([
            'success' => true,
            'data' => $horarioReceso,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(HorarioReceso $horarioReceso): JsonResponse
    {
        $horarioReceso->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}